/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#include "osdinput.hpp"

#include "../../main/application.hpp"

using namespace NMM;

OSDInputState::OSDInputState( string id,  MMBoxApplication* _app ) : MMBoxState( id, _app ) {
  manager = app->getOsdManager();
}

OSDInputState::~OSDInputState() {
}

Result OSDInputState::doCreate( string ) {
  //cerr << "OSD create" << endl;
  return( SUCCESS );
}

Result OSDInputState::doKill() {
  //cerr << "OSD kill" << endl;
  manager->deleteMessage();
  return( SUCCESS );
}

Result OSDInputState::Back() {
  manager->update();

  return( SUCCESS );
}

Result OSDInputState::Left() {
  manager->messageLeft();
  manager->update();

  return(SUCCESS);
}

Result OSDInputState::Right() {
  manager->messageRight();
  manager->update();

  return(SUCCESS);
}

Result OSDInputState::Up() {
  manager->messageLeft();
  manager->update();

  return(SUCCESS);
}

Result OSDInputState::Down() {
  manager->messageRight();
  manager->update();

  return(SUCCESS);
}

Result OSDInputState::Return() {
  
  deactivate();
  goToLastState();
  app->receiveMessage( manager->messageID() );
  
  return(SUCCESS);
}


