/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include <qapplication.h>
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include "nmm/base/ProxyApplication.hpp"
#include "nmm/utils/NamedObject.hpp"

#include "qcamctrl.h"



int main(int argc, char *argv[])
{
  try {
    NMM::NamedObject::getGlobalInstance().setDebugStream(0, NMM::NamedObject::ALL_LEVELS);
    NMM::NamedObject::getGlobalInstance().setWarningStream(0, NMM::NamedObject::ALL_LEVELS);
    NMM::NamedObject::getGlobalInstance().setMessageStream(0, NMM::NamedObject::ALL_LEVELS);

    QApplication a(argc, argv);

    NMM::NMMApplication* app = NMM::ProxyApplication::getApplication(argc, argv);

    a.setFont(QFont("helvetica", 9));
    QTranslator tor( 0 );
    // set the location where your .qm files are in load() below as the last parameter instead of "."
    // for development, use "/" to use the english original as
    // .qm files are stored in the base project directory.
    tor.load( QString("qcamctrl.") + QTextCodec::locale(), "." );
    a.installTranslator( &tor );
    /* uncomment the following line, if you want a Windows 95 look*/
    // a.setStyle(WindowsStyle);

    QCamCtrlApp qcamctrl(*app);
    a.setMainWidget(&qcamctrl);

    qcamctrl.show();

    int retval = a.exec();

    return retval;
  } catch (...) {

  }
}


