/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef QGRAPHWIDGET_H
#define QGRAPHWIDGET_H

#include <qwidget.h>
#include <list>

using namespace std;

/**
  *@author Michael Repplinger
  */
namespace NMM  {
  class INode;
}

class QGraphWidget   {

public: 
  QGraphWidget(const list<QString>& = list<QString>() );
  ~QGraphWidget();

        std::list<NMM::INode*>& getNodeList()       {return __node_list; }

  const std::list<NMM::INode*>& getNodeList() const {return __node_list; }

  void addNode(NMM::INode* node) {__node_list.push_back(node) ;}

  void init();

  void deinit();

  void activate();

  void deactivate();

  void start();

  void stop();

  inline  const std::list<QString>& getHeader() const { return __header_list; }

//  void connect();
//
//  void disconnect();
private:
  typedef std::list<NMM::INode*>::iterator InternalIt;
  typedef std::list<NMM::INode*>::const_iterator CInternalIt;

  std::list<NMM::INode*> __node_list;
  std::list<QString>     __header_list;
};

#endif
