/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include "qregwizardview.hpp"
#include "PluginView.hpp"
#include "RegistryView.hpp"
#include <qlayout.h>
#include <qsplitter.h>

QRegWizardView::QRegWizardView(NMM::NMMApplication& na, QWidget *parent) : QWidget(parent), nmm_application(na)
{
  allocate();
}

QRegWizardView::~QRegWizardView()
{
}

void QRegWizardView::slotDocumentChanged()
{
  //TODO update the view

}

void QRegWizardView::allocate() {
  __current_splitter = new QSplitter(this);
  __top_level = new QGridLayout(this, 1, 1);
  __top_level->addWidget(__current_splitter, 0, 0);


  PluginView* plugin_view = new PluginView(nmm_application, __current_splitter);
  plugin_view->setMaximumWidth(220);
  addView(plugin_view);
  addView(new RegistryView(nmm_application, __current_splitter));
}

void QRegWizardView::addView(View* widget) {
  QSplitter *old_splitter = __current_splitter;
  __current_splitter->moveToFirst(widget);
  __current_splitter = new QSplitter(__current_splitter);
    old_splitter->moveToLast(__current_splitter);
  __views.push_back(widget);
}

void QRegWizardView::updateView() {
  for (unsigned int i = 0; i < __views.size(); ++i) {
    __views[i]->updateView();
  }
}
