/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef QREGWIZARDVIEW_H
#define QREGWIZARDVIEW_H

// include files for QT
#include <qwidget.h>
#include <vector>

class QSplitter;
class View;
class QGridLayout;
/**
 * This class provides an incomplete base for your application view. 
 */

namespace NMM {
  class NMMApplication;
}

class QRegWizardView : public QWidget
{
Q_OBJECT
public:
  QRegWizardView(NMM::NMMApplication& na, QWidget *parent=0);
  ~QRegWizardView();

  void updateView();  
protected slots:
  void slotDocumentChanged();


private: //methods
  void allocate();
  void addView(View* widget);
private:
  QGridLayout*  __top_level;
  std::vector<View*> __views;
  QSplitter*    __current_splitter;
  NMM::NMMApplication& nmm_application;
};

#endif
