/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Christian Gerstner <gerstner@graphics.cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include "ContainerWidget.hpp"
#include <iostream>

using namespace std;

ContainerWidget::ContainerWidget(QWidget *parent, const char *name, WFlags f) : QWidget(parent, name, f)  { 
    layout = new QVBoxLayout(this);
    container = new QtXEmbedContainer(this);
    layout->addWidget(container);
    setFocusPolicy(StrongFocus);   
}


ContainerWidget::~ContainerWidget() {
    container->releaseKeyboard();
    discardWindow();
    if(container) delete container;  
    if(layout) delete layout;
}

void ContainerWidget::embedWindow(const int wid){
    container->embed(wid, false);
    container->grabKeyboard();
    container->setFocus();
}

void ContainerWidget::discardWindow(){
  container->discardClient();
}


