/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Eric Peters <epeters@graphics.cs.uni-sb.de>
 *                    Christian Gerstner <gerstner@graphics.cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _NMM_VCORE_GUI_MYLINEEDIT_HPP_
#define _NMM_VCORE_GUI_MYLINEEDIT_HPP_ _NMM_VCORE_GUI_MYLINEEDIT_HPP_

#include <qlineedit.h>
#include <string>

using namespace std;

class MyLineEdit : public QLineEdit
{
  Q_OBJECT
public:
  /**
   * The class QLineEdit had to be extended as it was not possible
   * to set neither an integer nor a string value into a QLineEdit
   */
  MyLineEdit(QWidget*, const char*);
public slots:
  /**
   * create a QString from a string and set it into the editline
   */
  void setMyText(string);
  /**
   * create a QString from an integer and set it into the editline
   */
  void setMyText(int);
};

#endif //_NMM_VCORE_GUI_MYLINEEDIT_HPP_
