
#include "IFileMetaInformation.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  bool IFileMetaInformation::fillMetaInformation(const string& name)
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    TInValue<string > name_value(name, false);
    Event event("IFileMetaInformation::fillMetaInformation", &name_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getAccessTime()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getAccessTime");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  long IFileMetaInformation::getNumAccessTime()
      throw(const Exception&)
  {
    TOutValue<long > return_value;
    Event event("IFileMetaInformation::getNumAccessTime");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getModifyTime()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getModifyTime");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  long IFileMetaInformation::getNumModifyTime()
      throw(const Exception&)
  {
    TOutValue<long > return_value;
    Event event("IFileMetaInformation::getNumModifyTime");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getCreationTime()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getCreationTime");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  long IFileMetaInformation::getNumCreationTime()
      throw(const Exception&)
  {
    TOutValue<long > return_value;
    Event event("IFileMetaInformation::getNumCreationTime");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getTitle()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getTitle");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getAlbum()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getAlbum");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getArtist()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getArtist");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getGenre()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getGenre");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getDate()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getDate");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getMimeType()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getMimeType");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getAudioFormat()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getAudioFormat");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IFileMetaInformation::getVideoFormat()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IFileMetaInformation::getVideoFormat");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int IFileMetaInformation::getMode()
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IFileMetaInformation::getMode");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool IFileMetaInformation::getIsDir()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("IFileMetaInformation::getIsDir");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IFileMetaInformation::IFileMetaInformation_type = "IFileMetaInformation";
  TIFactoryObject<IFileMetaInformation > __IFileMetaInformation_prototype("IFileMetaInformation");


  const char* IFileMetaInformation::fillMetaInformation_event = "IFileMetaInformation::fillMetaInformation";
  const char* IFileMetaInformation::getAccessTime_event = "IFileMetaInformation::getAccessTime";
  const char* IFileMetaInformation::getNumAccessTime_event = "IFileMetaInformation::getNumAccessTime";
  const char* IFileMetaInformation::getModifyTime_event = "IFileMetaInformation::getModifyTime";
  const char* IFileMetaInformation::getNumModifyTime_event = "IFileMetaInformation::getNumModifyTime";
  const char* IFileMetaInformation::getCreationTime_event = "IFileMetaInformation::getCreationTime";
  const char* IFileMetaInformation::getNumCreationTime_event = "IFileMetaInformation::getNumCreationTime";
  const char* IFileMetaInformation::getTitle_event = "IFileMetaInformation::getTitle";
  const char* IFileMetaInformation::getAlbum_event = "IFileMetaInformation::getAlbum";
  const char* IFileMetaInformation::getArtist_event = "IFileMetaInformation::getArtist";
  const char* IFileMetaInformation::getGenre_event = "IFileMetaInformation::getGenre";
  const char* IFileMetaInformation::getDate_event = "IFileMetaInformation::getDate";
  const char* IFileMetaInformation::getMimeType_event = "IFileMetaInformation::getMimeType";
  const char* IFileMetaInformation::getAudioFormat_event = "IFileMetaInformation::getAudioFormat";
  const char* IFileMetaInformation::getVideoFormat_event = "IFileMetaInformation::getVideoFormat";
  const char* IFileMetaInformation::getMode_event = "IFileMetaInformation::getMode";
  const char* IFileMetaInformation::getIsDir_event = "IFileMetaInformation::getIsDir";


}


