
#include "INavFile.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  list<string >  INavFile::getDirectoryList(const string& dir)
      throw(const Exception&)
  {
    TOutValue<list<string >  > return_value;
    TInValue<string > dir_value(dir, false);
    Event event("INavFile::getDirectoryList", &dir_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  list<string >  INavFile::getFileList(const string& dir)
      throw(const Exception&)
  {
    TOutValue<list<string >  > return_value;
    TInValue<string > dir_value(dir, false);
    Event event("INavFile::getFileList", &dir_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* INavFile::INavFile_type = "INavFile";
  TIFactoryObject<INavFile > __INavFile_prototype("INavFile");


  const char* INavFile::getDirectoryList_event = "INavFile::getDirectoryList";
  const char* INavFile::getFileList_event = "INavFile::getFileList";


}


