
#ifndef NMM_INavFile_HPP
#define NMM_INavFile_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class INavFile : virtual public Interface { 
  public:
    INavFile() {  setTypeInfo(TypeInfo(INavFile::INavFile_type, "NMM")); };

    INavFile(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(INavFile::INavFile_type, "NMM")); setEventReceiver(parent); };

    virtual ~INavFile() {};

    static const char* INavFile_type;

    virtual  string getInterfaceType() const { return INavFile_type; }

    Interface* copy() const { return new INavFile(*this); }
    static const char* getDirectoryList_event;
    static const char* getFileList_event;
    /** Return the first level directory childs of dir.
	The string return is a coma ',' separate list of directory name.
        @param dir directory to scan. */

    virtual list<string >  getDirectoryList(const string& dir)
      throw(const Exception&);
    /** Return the name of files contained at dir.
	The string return is a coma ',' separate list of files.
	@param dir directory to scan. */

    virtual list<string >  getFileList(const string& dir)
      throw(const Exception&);


  };

  typedef auto_ptr<INavFile> INavFile_var;




}

#endif
