/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Marco Lohse <mlohse@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_PRIVATEBUFFER_HPP_
#define _NMM_PRIVATEBUFFER_HPP_

#include "BufferManager.hpp"

namespace NMM {

  class PrivateBuffer : public BufferManager, public NamedObject {

  private:

    Buffer *my_buffer;
    mutable int busy;
  protected:
    ~PrivateBuffer() ;
    virtual void erase() const;

  public:

    PrivateBuffer(Buffer *my_buffer = 0, const char* name = "PrivateBuffer");

    Buffer* requestBuffer (const size_t size) const;
    void releaseBuffer (Buffer* buffer) const;
    void setBuffer (Buffer* buffer);
  };

}

#endif //_NMM_PRIVATEBUFFER_HPP_
