/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Florian Winter <fw@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#include "UDPGeneric.hpp"

#include <iostream>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>    
#include <netinet/tcp.h>
#include <errno.h>

namespace NMM {


  UDPGeneric::UDPGeneric()
  {

  }


  UDPGeneric::~UDPGeneric() {
  }

  void UDPGeneric::createException(int __errno) const {
    switch(__errno) {
    case EPIPE:
      cerr << "The other end closed the socket unexpectedly or a read is executed on a shut down socket." << endl;
      break;
    case ETIMEDOUT:
      cerr << "The other end didn't acknowledge retransmitted data after some time." << endl;
      break;  
    case EAFNOSUPPORT:
      cerr << "Passed socket address type in sin_family was not AF_INET." << endl;
      break;
    default:
      cerr << "Unknown error" << endl;
    }
  }


}




