
#include "IMMBoxApplication.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  string IMMBoxApplication::getStateSessionLocation(const string& id)
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    TInValue<string > id_value(id, false);
    Event event("IMMBoxApplication::getStateSessionLocation", &id_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  IMMBoxState* IMMBoxApplication::createDistState(const string& id)
      throw(const Exception&)
  {
    TOutValue<IMMBoxState* > return_value;
    TInValue<string > id_value(id, false);
    Event event("IMMBoxApplication::createDistState", &id_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IMMBoxApplication::deleteDistState(const string& id)
      throw(const Exception&)
  {
    TInValue<string > id_value(id, false);
    Event event("IMMBoxApplication::deleteDistState", &id_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IMMBoxApplication::IMMBoxApplication_type = "IMMBoxApplication";
  TIFactoryObject<IMMBoxApplication > __IMMBoxApplication_prototype("IMMBoxApplication");


  const char* IMMBoxApplication::getStateSessionLocation_event = "IMMBoxApplication::getStateSessionLocation";
  const char* IMMBoxApplication::createDistState_event = "IMMBoxApplication::createDistState";
  const char* IMMBoxApplication::deleteDistState_event = "IMMBoxApplication::deleteDistState";


}


