
#ifndef NMM_IOggVorbis_HPP
#define NMM_IOggVorbis_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IOggVorbis : virtual public Interface { 
  public:
    IOggVorbis() {  setTypeInfo(TypeInfo(IOggVorbis::IOggVorbis_type, "NMM")); };

    IOggVorbis(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IOggVorbis::IOggVorbis_type, "NMM")); setEventReceiver(parent); };

    virtual ~IOggVorbis() {};

    static const char* IOggVorbis_type;

    virtual  string getInterfaceType() const { return IOggVorbis_type; }

    Interface* copy() const { return new IOggVorbis(*this); }
    static const char* getUserComments_event;
    static const char* getVendor_event;

    virtual string getUserComments()
      throw(const Exception&);

    virtual string getVendor()
      throw(const Exception&);


  };

  typedef auto_ptr<IOggVorbis> IOggVorbis_var;




}

#endif
