
#ifndef NMM_IScopeImpl_HPP
#define NMM_IScopeImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IScope.hpp"


namespace NMM
{

  class IScopeImpl  : public virtual NMMObject { 
  public:
    IScopeImpl() { addInterface(new IScope(*this)); registerEvents(); };

    virtual ~IScopeImpl() {};

  protected:
    /**
     * this method enables or disables the blur effect.
     */

    virtual Result setBlurEnabled(const bool& toggle) = 0;
    /**
     * sets the intensity of the blur effect.
     */

    virtual Result setBlurStep(const int& value) = 0;


  private:
    void registerEvents();
  };

}

#endif
