
#ifndef NMM_IAVMux_HPP
#define NMM_IAVMux_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /** Audio/video mux interface. */

  class IAVMux : virtual public Interface { 
  public:
  enum Label { 
    LABEL_VIDEO = 1 , 
    LABEL_AUDIO = 2  };

    IAVMux() {  setTypeInfo(TypeInfo(IAVMux::IAVMux_type, "NMM")); };

    IAVMux(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IAVMux::IAVMux_type, "NMM")); setEventReceiver(parent); };

    virtual ~IAVMux() {};

    static const char* IAVMux_type;

    virtual  string getInterfaceType() const { return IAVMux_type; }

    Interface* copy() const { return new IAVMux(*this); }
    static const char* setSyncMode_event;
    /**
     * Enable/disable synchronized mode.
     * Enables or disables synchronized mode.
     * In synchronized mode, buffers are sorted for increasing timestamps.
     * In normal mode, buffers are output in the order of arrival.
     * @param value true to enable synchronized mode
     */

    virtual void setSyncMode(const bool& value)
      throw(const Exception&);


  };

  typedef auto_ptr<IAVMux> IAVMux_var;

  OValueStream& operator<<(OValueStream& ov, const IAVMux::Label& t);
  IValueStream& operator>>(IValueStream& iv, IAVMux::Label& t);



}

#endif
