
#ifndef NMM_IFormatChange_HPP
#define NMM_IFormatChange_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class Format;

  class IFormatChange : virtual public Interface { 
  public:
    IFormatChange() {  setTypeInfo(TypeInfo(IFormatChange::IFormatChange_type, "NMM")); };

    IFormatChange(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IFormatChange::IFormatChange_type, "NMM")); setEventReceiver(parent); };

    virtual ~IFormatChange() {};

    static const char* IFormatChange_type;

    virtual  string getInterfaceType() const { return IFormatChange_type; }

    Interface* copy() const { return new IFormatChange(*this); }
    static const char* setFormat_event;
    static Event* create_setFormat(const Format& new_format);
  /* instream (protected) and non-instream (public) */    
    virtual Result setFormat(const Format& new_format) /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<IFormatChange> IFormatChange_var;




}

#endif
