
#ifndef NMM_IJackImpl_HPP
#define NMM_IJackImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IJack.hpp"


namespace NMM
{

  class IJackImpl  : public virtual NMMObject { 
  public:
    IJackImpl() { addInterface(new IJack(*this)); registerEvents(); };

    virtual ~IJackImpl() {};

  protected:

    virtual INode* getIParent() = 0;

    virtual string getJackTag() const = 0;
    /**
     * Returns true, if this Jack is connected, otherwise false.
     */

    virtual bool isConnected() const = 0;

    virtual void setTransportStrategy(const TSAddress* address) 
      throw(const BindingException&) = 0;
    /**
     * Disconnect from partner jack.
     */

    virtual void disconnect() = 0;

    virtual void connectToJack() /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
