
#ifndef NMM_INamed_HPP
#define NMM_INamed_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class INamed : virtual public Interface { 
  public:
    INamed() {  setTypeInfo(TypeInfo(INamed::INamed_type, "NMM")); };

    INamed(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(INamed::INamed_type, "NMM")); setEventReceiver(parent); };

    virtual ~INamed() {};

    static const char* INamed_type;

    virtual  string getInterfaceType() const { return INamed_type; }

    Interface* copy() const { return new INamed(*this); }
    static const char* setName_event;
    static const char* getName_event;
    static const char* setErrorStream_event;
    static const char* setDebugStream_event;
    static const char* setWarningStream_event;
    static const char* setMessageStream_event;

    virtual void setName(const string& value)
      throw(const Exception&);

    virtual string getName() const
      throw(const Exception&);

    virtual void setErrorStream(const string& filname, const int& debug_level)
      throw(const Exception&);

    virtual void setDebugStream(const string& filname, const int& debug_level)
      throw(const Exception&);

    virtual void setWarningStream(const string& filename, const int& debug_level)
      throw(const Exception&);

    virtual void setMessageStream(const string& feilname, const int& debug_level)
      throw(const Exception&);


  };

  typedef auto_ptr<INamed> INamed_var;




}

#endif
