
#ifndef NMM_IQueuedImpl_HPP
#define NMM_IQueuedImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IQueued.hpp"

#include "INodeImpl.hpp"

namespace NMM
{

  class IQueuedImpl  : public virtual NMMObject { 
  public:
    IQueuedImpl() { addInterface(new IQueued(*this)); registerEvents(); };

    virtual ~IQueuedImpl() {};

  protected:

    virtual unsigned int getSize(const string& id = "default") const = 0;

    virtual unsigned int getMaxSize(const string& id = "default") const = 0;

    virtual Result setMaxSize(const unsigned int& size, const string& id = "default") = 0;

    virtual IQueued::Mode getMode(const string& id = "default") const = 0;

    virtual Result setMode(const IQueued::Mode& mode, const string& id = "default") = 0;


  private:
    void registerEvents();
  };

  class IBiDirQueuedNodeImpl  : public virtual NMMObject { 
  public:
    IBiDirQueuedNodeImpl() { addInterface(new IBiDirQueuedNode(*this)); registerEvents(); };

    virtual ~IBiDirQueuedNodeImpl() {};

  protected:

    virtual unsigned int getDownstreamSize(const string& id = "default") const = 0;

    virtual unsigned int getDownstreamMaxSize(const string& id = "default") const = 0;

    virtual IQueued::Mode getDownstreamMode(const string& id = "default") const = 0;

    virtual Result setDownstreamMaxSize(const unsigned int& size, const string& id = "default") /* limited(INode::CONSTRUCTED) */ = 0;

    virtual Result setDownstreamMode(const IQueued::Mode& mode, const string& id = "default") /* limited(INode::CONSTRUCTED) */ = 0;

    virtual Result unlimitDownstreamSize() /* in-stream */  = 0;

    virtual Result limitDownstreamSize() /* in-stream */  = 0;

    virtual unsigned int getUpstreamSize(const string& id = "default") const = 0;

    virtual unsigned int getUpstreamMaxSize(const string& id = "default") const = 0;

    virtual IQueued::Mode getUpstreamMode(const string& id = "default") const = 0;

    virtual Result setUpstreamMaxSize(const unsigned int& size, const string& id = "default") /* limited(INode::CONSTRUCTED) */ = 0;

    virtual Result setUpstreamMode(const IQueued::Mode& mode, const string& id = "default") /* limited(INode::CONSTRUCTED) */ = 0;

    virtual Result setMaxSize(const unsigned int& size, const string& id = "default") /* limited(INode::CONSTRUCTED) */ = 0;

    virtual Result setMode(const IQueued::Mode& mode, const string& id = "default") /* limited(INode::CONSTRUCTED) */ = 0;


  private:
    void registerEvents();
  };

}

#endif
