
#include "ITransportStrategy.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ITransportStrategy::setSendValueStream(const string& input_stream)
      throw(const Exception&)
  {
    TInValue<string > input_stream_value(input_stream, false);
    Event event("ITransportStrategy::setSendValueStream", &input_stream_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITransportStrategy::setReceiveValueStream(const string& input_stream) /* in-stream */ 
      throw(const Exception&)
  {
    TInValue<string > input_stream_value(input_stream, false);
    Event event("ITransportStrategy::setReceiveValueStream", &input_stream_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ITransportStrategy::ITransportStrategy_type = "ITransportStrategy";
  TIFactoryObject<ITransportStrategy > __ITransportStrategy_prototype("ITransportStrategy");


  const char* ITransportStrategy::setSendValueStream_event = "ITransportStrategy::setSendValueStream";
  const char* ITransportStrategy::setReceiveValueStream_event = "ITransportStrategy::setReceiveValueStream";
  Event* ITransportStrategy::create_setReceiveValueStream(const string& input_stream)
  {
    TInValue<string >* input_stream_value = new TInValue<string >();
    input_stream_value->setValue(input_stream);

    return new Event("ITransportStrategy::setReceiveValueStream", input_stream_value);
  }



}


