
#include "ITransportStrategyConfig.hpp"
#include "nmm/base/InterfaceFactory.hpp"

#include "nmm/base/format/Format.hpp"

namespace NMM
{
  
  
  void ITransportStrategyConfig::configureForInputJack(const Format& format)
      throw(const Exception&)
  {
    TInValue<Format > format_value(format, false);
    Event event("ITransportStrategyConfig::configureForInputJack", &format_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITransportStrategyConfig::configureForOutputJack(const Format& format)
      throw(const Exception&)
  {
    TInValue<Format > format_value(format, false);
    Event event("ITransportStrategyConfig::configureForOutputJack", &format_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ITransportStrategyConfig::ITransportStrategyConfig_type = "ITransportStrategyConfig";
  TIFactoryObject<ITransportStrategyConfig > __ITransportStrategyConfig_prototype("ITransportStrategyConfig");


  const char* ITransportStrategyConfig::configureForInputJack_event = "ITransportStrategyConfig::configureForInputJack";
  const char* ITransportStrategyConfig::configureForOutputJack_event = "ITransportStrategyConfig::configureForOutputJack";


}


