
#ifndef NMM_ICompositeNode_HPP
#define NMM_ICompositeNode_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/base/INode.hpp"

namespace NMM
{

  class ICompositeNode : virtual public Interface { 
  public:
    ICompositeNode() {  setTypeInfo(TypeInfo(ICompositeNode::ICompositeNode_type, "NMM")); };

    ICompositeNode(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ICompositeNode::ICompositeNode_type, "NMM")); setEventReceiver(parent); };

    virtual ~ICompositeNode() {};

    static const char* ICompositeNode_type;

    virtual  string getInterfaceType() const { return ICompositeNode_type; }

    Interface* copy() const { return new ICompositeNode(*this); }
    static const char* addNode_event;
    static const char* addNodeWithInterfaces_event;
    static const char* renameInputJackTag_event;
    static const char* renameOutputJackTag_event;

    virtual unsigned int addNode(const INode& node) /* limited(INode::CONSTRUCTED) */
      throw(const Exception&, const IllegalStateException&);

    virtual unsigned int addNodeWithInterfaces(const INode& node, const list<Interface* > & interfaces) /* limited(INode::CONSTRUCTED) */
      throw(const Exception&, const IllegalStateException&);

    virtual Result renameInputJackTag(const string& old_cn_jack_tag, const string& new_cn_jack_tag) /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&);

    virtual Result renameOutputJackTag(const string& old_cn_jack_tag, const string& new_cn_jack_tag) /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&);


  };

  typedef auto_ptr<ICompositeNode> ICompositeNode_var;




}

#endif
