
#ifndef NMM_ICompositeNodeImpl_HPP
#define NMM_ICompositeNodeImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ICompositeNode.hpp"

#include "nmm/interfaces/base/INodeImpl.hpp"

namespace NMM
{

  class ICompositeNodeImpl  : public virtual NMMObject { 
  public:
    ICompositeNodeImpl() { addInterface(new ICompositeNode(*this)); registerEvents(); };

    virtual ~ICompositeNodeImpl() {};

  protected:

    virtual unsigned int addNode(const INode& node) /* limited(INode::CONSTRUCTED) */ = 0;

    virtual unsigned int addNodeWithInterfaces(const INode& node, const list<Interface* > & interfaces) /* limited(INode::CONSTRUCTED) */ = 0;

    virtual Result renameInputJackTag(const string& old_cn_jack_tag, const string& new_cn_jack_tag) /* limited(INode::INITIALIZED) */ = 0;

    virtual Result renameOutputJackTag(const string& old_cn_jack_tag, const string& new_cn_jack_tag) /* limited(INode::OUTPUT_INITIALIZED) */ = 0;


  private:
    void registerEvents();
  };

}

#endif
