
#include "IMultiAudioSinkSynchronizer.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  int IMultiAudioSinkSynchronizer::addAudioSinkController(const ISinkController* controller)
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    TInValue<ISinkController* > controller_value (const_cast<ISinkController* >(controller), false);
    Event event("IMultiAudioSinkSynchronizer::addAudioSinkController", &controller_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IMultiAudioSinkSynchronizer::IMultiAudioSinkSynchronizer_type = "IMultiAudioSinkSynchronizer";
  TIFactoryObject<IMultiAudioSinkSynchronizer > __IMultiAudioSinkSynchronizer_prototype("IMultiAudioSinkSynchronizer");


  const char* IMultiAudioSinkSynchronizer::addAudioSinkController_event = "IMultiAudioSinkSynchronizer::addAudioSinkController";


}


