
#include "IMultiVideoSinkSynchronizer.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  int IMultiVideoSinkSynchronizer::addVideoSinkController(const ISinkController* controller)
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    TInValue<ISinkController* > controller_value (const_cast<ISinkController* >(controller), false);
    Event event("IMultiVideoSinkSynchronizer::addVideoSinkController", &controller_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IMultiVideoSinkSynchronizer::IMultiVideoSinkSynchronizer_type = "IMultiVideoSinkSynchronizer";
  TIFactoryObject<IMultiVideoSinkSynchronizer > __IMultiVideoSinkSynchronizer_prototype("IMultiVideoSinkSynchronizer");


  const char* IMultiVideoSinkSynchronizer::addVideoSinkController_event = "IMultiVideoSinkSynchronizer::addVideoSinkController";


}


