
#ifndef NMM_IMultiVideoSinkSynchronizer_HPP
#define NMM_IMultiVideoSinkSynchronizer_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "ISinkSynchronizer.hpp"

namespace NMM
{

  class IMultiVideoSinkSynchronizer : virtual public Interface { 
  public:
    IMultiVideoSinkSynchronizer() {  setTypeInfo(TypeInfo(IMultiVideoSinkSynchronizer::IMultiVideoSinkSynchronizer_type, "NMM")); };

    IMultiVideoSinkSynchronizer(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IMultiVideoSinkSynchronizer::IMultiVideoSinkSynchronizer_type, "NMM")); setEventReceiver(parent); };

    virtual ~IMultiVideoSinkSynchronizer() {};

    static const char* IMultiVideoSinkSynchronizer_type;

    virtual  string getInterfaceType() const { return IMultiVideoSinkSynchronizer_type; }

    Interface* copy() const { return new IMultiVideoSinkSynchronizer(*this); }
    static const char* addVideoSinkController_event;
    /**
     * Adds an video sink controller.
     * This adds the controller for an video sink.
     * A new id is returned.
     * @param controller controller for this sink
     * @return id video sink id
     */

    virtual int addVideoSinkController(const ISinkController* controller)
      throw(const Exception&);


  };

  typedef auto_ptr<IMultiVideoSinkSynchronizer> IMultiVideoSinkSynchronizer_var;




}

#endif
