
#ifndef NMM_IMultiVideoSinkSynchronizerImpl_HPP
#define NMM_IMultiVideoSinkSynchronizerImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IMultiVideoSinkSynchronizer.hpp"

#include "ISinkSynchronizerImpl.hpp"

namespace NMM
{

  class IMultiVideoSinkSynchronizerImpl  : public virtual NMMObject { 
  public:
    IMultiVideoSinkSynchronizerImpl() { addInterface(new IMultiVideoSinkSynchronizer(*this)); registerEvents(); };

    virtual ~IMultiVideoSinkSynchronizerImpl() {};

  protected:
    /**
     * Adds an video sink controller.
     * This adds the controller for an video sink.
     * A new id is returned.
     * @param controller controller for this sink
     * @return id video sink id
     */

    virtual int addVideoSinkController(const ISinkController* controller) = 0;


  private:
    void registerEvents();
  };

}

#endif
