
#ifndef NMM_ISynchronizedSinkImpl_HPP
#define NMM_ISynchronizedSinkImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ISynchronizedSink.hpp"

#include "ISynchronizedImpl.hpp"
#include "ISinkControllerImpl.hpp"

namespace NMM
{

  class ISynchronizedSinkImpl  : virtual public ISynchronizedImpl { 
  public:
    ISynchronizedSinkImpl() { addInterface(new ISynchronizedSink(*this)); registerEvents(); };

    virtual ~ISynchronizedSinkImpl() {};

  protected:
    /**
     * Get the controller for this node.
     * The controller interface is needed by the synchronizer to communicate with the node.
     */

    virtual ISinkController* getController() = 0;
    /**
     * Check if sink is a buffered sink.
     * Audio sinks for example are buffered sinks, video sinks are unbuffered.
     */

    virtual bool isBuffered() const = 0;


  private:
    void registerEvents();
  };

}

#endif
