
#ifndef NMM_IDevice_HPP
#define NMM_IDevice_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/base/INode.hpp"

namespace NMM
{

  class IDevice : virtual public Interface { 
  public:
    IDevice() {  setTypeInfo(TypeInfo(IDevice::IDevice_type, "NMM")); };

    IDevice(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IDevice::IDevice_type, "NMM")); setEventReceiver(parent); };

    virtual ~IDevice() {};

    static const char* IDevice_type;

    virtual  string getInterfaceType() const { return IDevice_type; }

    Interface* copy() const { return new IDevice(*this); }
    static const char* setDevice_event;
    static const char* getDevice_event;

    virtual void setDevice(const string& value) /* limited(INode::CONSTRUCTED) */
      throw(const Exception&, const IllegalStateException&, const DeviceNotFoundException&, const WrongDeviceException&);

    virtual string getDevice() const
      throw(const Exception&);


  };

  typedef auto_ptr<IDevice> IDevice_var;




}

#endif
