
#ifndef NMM_IDeviceImpl_HPP
#define NMM_IDeviceImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IDevice.hpp"

#include "nmm/interfaces/base/INodeImpl.hpp"

namespace NMM
{

  class IDeviceImpl  : public virtual NMMObject { 
  public:
    IDeviceImpl() { addInterface(new IDevice(*this)); registerEvents(); };

    virtual ~IDeviceImpl() {};

  protected:

    virtual void setDevice(const string& value) /* limited(INode::CONSTRUCTED) */ 
      throw(const DeviceNotFoundException&, const WrongDeviceException&) = 0;

    virtual string getDevice() const = 0;


  private:
    void registerEvents();
  };

}

#endif
