
#include "IMultipleDevice.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IMultipleDevice::setDevice(const string& name, const string& value)
      throw(const Exception&)
  {
    TInValue<string > name_value(name, false);
    TInValue<string > value_value(value, false);
    Event event("IMultipleDevice::setDevice", &name_value, &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string IMultipleDevice::getDevice(const string& name)
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    TInValue<string > name_value(name, false);
    Event event("IMultipleDevice::getDevice", &name_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IMultipleDevice::IMultipleDevice_type = "IMultipleDevice";
  TIFactoryObject<IMultipleDevice > __IMultipleDevice_prototype("IMultipleDevice");


  const char* IMultipleDevice::setDevice_event = "IMultipleDevice::setDevice";
  const char* IMultipleDevice::getDevice_event = "IMultipleDevice::getDevice";


}


