
#ifndef NMM_ICDDAImpl_HPP
#define NMM_ICDDAImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ICDDA.hpp"

#include "nmm/interfaces/device/IDeviceImpl.hpp"

namespace NMM
{

  class ICDDAImpl  : virtual public IDeviceImpl { 
  public:
    ICDDAImpl() { addInterface(new ICDDA(*this)); registerEvents(); };

    virtual ~ICDDAImpl() {};

  protected:

    virtual Result setTrack(const int& track) = 0;

    virtual int getTrack() = 0;

    virtual void setRepeat(const bool& repeat) = 0;

    virtual bool getRepeat() = 0;

    virtual int getTotalTracks() = 0;

    virtual void numberTracks(const bool& number) = 0;

    virtual bool isFinished() = 0;

    virtual void setOneTrackOnly(const bool& enable) = 0;

    virtual bool getOneTrackOnly() = 0;


  private:
    void registerEvents();
  };

}

#endif
