
#ifndef NMM_ICDDB_HPP
#define NMM_ICDDB_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ICDDB : virtual public Interface { 
  public:
    ICDDB() {  setTypeInfo(TypeInfo(ICDDB::ICDDB_type, "NMM")); };

    ICDDB(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ICDDB::ICDDB_type, "NMM")); setEventReceiver(parent); };

    virtual ~ICDDB() {};

    static const char* ICDDB_type;

    virtual  string getInterfaceType() const { return ICDDB_type; }

    Interface* copy() const { return new ICDDB(*this); }
    static const char* setCDDBServer_event;
    static const char* getTrackName_event;
    static const char* getDiscTitle_event;
    static const char* getDiscArtist_event;
    static const char* setCDDB_event;
    static const char* getCDDB_event;

    virtual Result setCDDBServer(const string& host, const int& port)
      throw(const Exception&);

    virtual string getTrackName(const int& track)
      throw(const Exception&);

    virtual string getDiscTitle()
      throw(const Exception&);

    virtual string getDiscArtist()
      throw(const Exception&);

    virtual void setCDDB(const bool& enabled)
      throw(const Exception&);

    virtual bool getCDDB()
      throw(const Exception&);


  };

  typedef auto_ptr<ICDDB> ICDDB_var;




}

#endif
