
#include "IDVDNav.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IDVDNav::selectButton(const int& button)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<int > button_value(button, false);
    Event event("IDVDNav::selectButton", &button_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IDVDNav::activateButton(const int& button)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<int > button_value(button, false);
    Event event("IDVDNav::activateButton", &button_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IDVDNav::activateSelectedButton()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IDVDNav::activateSelectedButton");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IDVDNav::goUp()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IDVDNav::goUp");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IDVDNav::buttonUp()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IDVDNav::buttonUp");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IDVDNav::buttonDown()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IDVDNav::buttonDown");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IDVDNav::buttonRight()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IDVDNav::buttonRight");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IDVDNav::buttonLeft()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IDVDNav::buttonLeft");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int IDVDNav::getSelectedButton()
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IDVDNav::getSelectedButton");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IDVDNav::IDVDNav_type = "IDVDNav";
  TIFactoryObject<IDVDNav > __IDVDNav_prototype("IDVDNav");


  const char* IDVDNav::selectButton_event = "IDVDNav::selectButton";
  const char* IDVDNav::activateButton_event = "IDVDNav::activateButton";
  const char* IDVDNav::activateSelectedButton_event = "IDVDNav::activateSelectedButton";
  const char* IDVDNav::goUp_event = "IDVDNav::goUp";
  const char* IDVDNav::buttonUp_event = "IDVDNav::buttonUp";
  const char* IDVDNav::buttonDown_event = "IDVDNav::buttonDown";
  const char* IDVDNav::buttonRight_event = "IDVDNav::buttonRight";
  const char* IDVDNav::buttonLeft_event = "IDVDNav::buttonLeft";
  const char* IDVDNav::getSelectedButton_event = "IDVDNav::getSelectedButton";


}


