
#ifndef NMM_IDVDNav_HPP
#define NMM_IDVDNav_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IDVDNav : virtual public Interface { 
  public:
    IDVDNav() {  setTypeInfo(TypeInfo(IDVDNav::IDVDNav_type, "NMM")); };

    IDVDNav(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IDVDNav::IDVDNav_type, "NMM")); setEventReceiver(parent); };

    virtual ~IDVDNav() {};

    static const char* IDVDNav_type;

    virtual  string getInterfaceType() const { return IDVDNav_type; }

    Interface* copy() const { return new IDVDNav(*this); }
    static const char* selectButton_event;
    static const char* activateButton_event;
    static const char* activateSelectedButton_event;
    static const char* goUp_event;
    static const char* buttonUp_event;
    static const char* buttonDown_event;
    static const char* buttonRight_event;
    static const char* buttonLeft_event;
    static const char* getSelectedButton_event;

    virtual Result selectButton(const int& button)
      throw(const Exception&);

    virtual Result activateButton(const int& button)
      throw(const Exception&);

    virtual Result activateSelectedButton()
      throw(const Exception&);

    virtual Result goUp()
      throw(const Exception&);

    virtual Result buttonUp()
      throw(const Exception&);

    virtual Result buttonDown()
      throw(const Exception&);

    virtual Result buttonRight()
      throw(const Exception&);

    virtual Result buttonLeft()
      throw(const Exception&);

    virtual int getSelectedButton()
      throw(const Exception&);


  };

  typedef auto_ptr<IDVDNav> IDVDNav_var;




}

#endif
