
#ifndef NMM_IDVDNavImpl_HPP
#define NMM_IDVDNavImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IDVDNav.hpp"


namespace NMM
{

  class IDVDNavImpl  : public virtual NMMObject { 
  public:
    IDVDNavImpl() { addInterface(new IDVDNav(*this)); registerEvents(); };

    virtual ~IDVDNavImpl() {};

  protected:

    virtual Result selectButton(const int& button) = 0;

    virtual Result activateButton(const int& button) = 0;

    virtual Result activateSelectedButton() = 0;

    virtual Result goUp() = 0;

    virtual Result buttonUp() = 0;

    virtual Result buttonDown() = 0;

    virtual Result buttonRight() = 0;

    virtual Result buttonLeft() = 0;

    virtual int getSelectedButton() = 0;


  private:
    void registerEvents();
  };

}

#endif
