
#ifndef NMM_IFileHandler_HPP
#define NMM_IFileHandler_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IFileHandler : virtual public Interface { 
  public:
    IFileHandler() {  setTypeInfo(TypeInfo(IFileHandler::IFileHandler_type, "NMM")); };

    IFileHandler(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IFileHandler::IFileHandler_type, "NMM")); setEventReceiver(parent); };

    virtual ~IFileHandler() {};

    static const char* IFileHandler_type;

    virtual  string getInterfaceType() const { return IFileHandler_type; }

    Interface* copy() const { return new IFileHandler(*this); }
    static const char* setFilename_event;

    virtual void setFilename(const string& name)
      throw(const Exception&);


  };

  typedef auto_ptr<IFileHandler> IFileHandler_var;




}

#endif
