
#ifndef NMM_ISendFilenameAndTimestamp_HPP
#define NMM_ISendFilenameAndTimestamp_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   * Sending of timestamps.
   *
   * Defines an event containing a filename and a timestamp that can
   * be sent by any node and caught by the application.
   */

  class ISendFilenameAndTimestamp : virtual public Interface { 
  public:
    ISendFilenameAndTimestamp() {  setTypeInfo(TypeInfo(ISendFilenameAndTimestamp::ISendFilenameAndTimestamp_type, "NMM")); };

    ISendFilenameAndTimestamp(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ISendFilenameAndTimestamp::ISendFilenameAndTimestamp_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISendFilenameAndTimestamp() {};

    static const char* ISendFilenameAndTimestamp_type;

    virtual  string getInterfaceType() const { return ISendFilenameAndTimestamp_type; }

    Interface* copy() const { return new ISendFilenameAndTimestamp(*this); }
    static const char* sendFilenameAndTimestamp_event;
    static Event* create_sendFilenameAndTimestamp(const string& fn, const Timestamp& ts);
  /* instream (protected) and non-instream (public) */        /**
     * Send the filename and timestamp
     * @param ts the timestamp to be sent
     */

    virtual Result sendFilenameAndTimestamp(const string& fn, const Timestamp& ts) /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ISendFilenameAndTimestamp> ISendFilenameAndTimestamp_var;




}

#endif
