
#include "ICopy.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ICopy::setNumberOfOutputs(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICopy::setNumberOfOutputs", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ICopy::ICopy_type = "ICopy";
  TIFactoryObject<ICopy > __ICopy_prototype("ICopy");


  const char* ICopy::setNumberOfOutputs_event = "ICopy::setNumberOfOutputs";


}


