
#ifndef NMM_ICopy_HPP
#define NMM_ICopy_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ICopy : virtual public Interface { 
  public:
    ICopy() {  setTypeInfo(TypeInfo(ICopy::ICopy_type, "NMM")); };

    ICopy(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ICopy::ICopy_type, "NMM")); setEventReceiver(parent); };

    virtual ~ICopy() {};

    static const char* ICopy_type;

    virtual  string getInterfaceType() const { return ICopy_type; }

    Interface* copy() const { return new ICopy(*this); }
    static const char* setNumberOfOutputs_event;

    virtual void setNumberOfOutputs(const int& value)
      throw(const Exception&);


  };

  typedef auto_ptr<ICopy> ICopy_var;




}

#endif
