
#include "ITrackSize.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ITrackSize::trackSize(const u_int64_t& bytes) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<u_int64_t > bytes_value(bytes, false);
    Event event("ITrackSize::trackSize", &bytes_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ITrackSize::ITrackSize_type = "ITrackSize";
  TIFactoryObject<ITrackSize > __ITrackSize_prototype("ITrackSize");


  const char* ITrackSize::trackSize_event = "ITrackSize::trackSize";
  Event* ITrackSize::create_trackSize(const u_int64_t& bytes)
  {
    TInValue<u_int64_t >* bytes_value = new TInValue<u_int64_t >();
    bytes_value->setValue(bytes);

    return new Event("ITrackSize::trackSize", bytes_value);
  }



}


