
#include "ITimeProgress.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ITimeProgress::setProgressUpdateInterval(const Interval& update_interval)
      throw(const Exception&)
  {
    TInValue<Interval > update_interval_value(update_interval, false);
    Event event("ITimeProgress::setProgressUpdateInterval", &update_interval_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITimeProgress::setProgressUpdateEnabled(const bool& enable_update)
      throw(const Exception&)
  {
    TInValue<bool > enable_update_value(enable_update, false);
    Event event("ITimeProgress::setProgressUpdateEnabled", &enable_update_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ITimeProgress::ITimeProgress_type = "ITimeProgress";
  TIFactoryObject<ITimeProgress > __ITimeProgress_prototype("ITimeProgress");


  const char* ITimeProgress::setProgressUpdateInterval_event = "ITimeProgress::setProgressUpdateInterval";
  const char* ITimeProgress::setProgressUpdateEnabled_event = "ITimeProgress::setProgressUpdateEnabled";


}


