
#include "ITVGuidePlugin.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  string ITVGuidePlugin::getName()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("ITVGuidePlugin::getName");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuidePlugin::start()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVGuidePlugin::start");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuidePlugin::stop()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVGuidePlugin::stop");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ITVGuidePlugin::enable()
      throw(const Exception&)
  {
    Event event("ITVGuidePlugin::enable");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITVGuidePlugin::disable()
      throw(const Exception&)
  {
    Event event("ITVGuidePlugin::disable");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  Result ITVGuidePlugin::init()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVGuidePlugin::init");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result ITVGuidePlugin::deinit()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("ITVGuidePlugin::deinit");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ITVGuidePlugin::getEnabled()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ITVGuidePlugin::getEnabled");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  ITVGuidePlugin::State ITVGuidePlugin::getState()
      throw(const Exception&)
  {
    TOutValue<ITVGuidePlugin::State > return_value;
    Event event("ITVGuidePlugin::getState");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ITVGuidePlugin::ITVGuidePlugin_type = "ITVGuidePlugin";
  TIFactoryObject<ITVGuidePlugin > __ITVGuidePlugin_prototype("ITVGuidePlugin");
  TValueConstructor< ITVGuidePlugin::State > __ITVGuidePlugin_State_prototype(TypeInfo("ITVGuidePlugin::State", "NMM"));

  OValueStream& operator<<(OValueStream& ov, const ITVGuidePlugin::State& t)
  {
    ov.beginType(TypeInfo("ITVGuidePlugin::State", "NMM"));
    ov << reinterpret_cast<const int&>(t);
    ov.endType();
    return ov;
  }

  IValueStream& operator>>(IValueStream& iv, ITVGuidePlugin::State& t)
  {
    if(iv.getCurrentTypeInfo() != TypeInfo("ITVGuidePlugin::State", "NMM")) {
      throw InvalidTypeException(TypeInfo("ITVGuidePlugin::State", "NMM"), iv.getCurrentTypeInfo());
    }
    iv.goDown();
    iv >> reinterpret_cast<int&>(t);
    iv.goUp();
    return iv;
  }



  const char* ITVGuidePlugin::getName_event = "ITVGuidePlugin::getName";
  const char* ITVGuidePlugin::start_event = "ITVGuidePlugin::start";
  const char* ITVGuidePlugin::stop_event = "ITVGuidePlugin::stop";
  const char* ITVGuidePlugin::enable_event = "ITVGuidePlugin::enable";
  const char* ITVGuidePlugin::disable_event = "ITVGuidePlugin::disable";
  const char* ITVGuidePlugin::init_event = "ITVGuidePlugin::init";
  const char* ITVGuidePlugin::deinit_event = "ITVGuidePlugin::deinit";
  const char* ITVGuidePlugin::getEnabled_event = "ITVGuidePlugin::getEnabled";
  const char* ITVGuidePlugin::getState_event = "ITVGuidePlugin::getState";


}


