
#ifndef NMM_ITVGuidePluginImpl_HPP
#define NMM_ITVGuidePluginImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ITVGuidePlugin.hpp"


namespace NMM
{

  class ITVGuidePluginImpl  : public virtual NMMObject { 
  public:
    ITVGuidePluginImpl() { addInterface(new ITVGuidePlugin(*this)); registerEvents(); };

    virtual ~ITVGuidePluginImpl() {};

  protected:
    /**
     * returns the name of the plugin
     */

    virtual string getName() = 0;
    /**
     * Starts an update
     */

    virtual Result start() = 0;
    /**
     * stops the update
     */

    virtual Result stop() = 0;
    /**
     * enables the Plugin
     */

    virtual void enable() = 0;
    /**
     * disables the plugin
     */

    virtual void disable() = 0;
    /**
     * initializes the plugin
     */

    virtual Result init() = 0;
    /**
     * deinitializes the plugin
     */

    virtual Result deinit() = 0;
    /**
     * get the status of enabled-flag
     *@return status of enabled-flag
     */

    virtual bool getEnabled() = 0;
    /**
     * get the current State of the Plugin
     *@return plugin-state
     */

    virtual ITVGuidePlugin::State getState() = 0;


  private:
    void registerEvents();
  };

}

#endif
