
#ifndef NMM_ITVManagerImpl_HPP
#define NMM_ITVManagerImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ITVManager.hpp"

#include "nmm/interfaces/base/INodeImpl.hpp"
#include "nmm/interfaces/base/IUsageNotifyImpl.hpp"

namespace NMM
{
  /**
   *This interface is used by the TVManager to notify applications about certain Events
   */

  class ITVManagerImpl  : public virtual NMMObject { 
  public:
    ITVManagerImpl() { addInterface(new ITVManager(*this)); registerEvents(); };

    virtual ~ITVManagerImpl() {};

  protected:

    virtual Result setChannel(const unsigned int& channel) = 0;

    virtual Result channelUp() = 0;

    virtual Result channelDown() = 0;

    virtual INode* getTVCard() = 0;

    virtual Result startGraph() = 0;

    virtual void setUsageNotify(const IUsageNotify* u) = 0;

    virtual void releaseGraph() = 0;
    /**
     *Indicates on channel-switch that the next channel is not available on the current TVCard and the source will be switched
     */

    virtual Result switchingSource() = 0;
    /**
     *Indicates that the application couldn't request the source exclusive and is only slave
     */

    virtual Result sharedSource() = 0;
    /**
     *Indocates, that the next channel is unavailable and therefore left out while channel-hopping
     */

    virtual Result skippingChannel() = 0;


  private:
    void registerEvents();
  };

}

#endif
