
#ifndef NMM_ITVTimerEventsImpl_HPP
#define NMM_ITVTimerEventsImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ITVTimerEvents.hpp"


namespace NMM
{
  /**
   *This interface represents the Events that are send by the TVTimer-Object
   */

  class ITVTimerEventsImpl  : public virtual NMMObject { 
  public:
    ITVTimerEventsImpl() { addInterface(new ITVTimerEvents(*this)); registerEvents(); };

    virtual ~ITVTimerEventsImpl() {};

  protected:
    /**
     *This method indicates, that a recoding has ended
     *@param id of the TVTimerEntry, that has ended
     */

    virtual Result recordingStopped(const unsigned int& id) /* in-stream */  = 0;
    /**
     *This method is called, if an TVCard is unavailable
     *@param TVTimerEntry, for wich the TVCard is unavailable
     */

    virtual Result tvcardUnavailable(const unsigned int& id) /* in-stream */  = 0;
    /**
     *Indicates a timer-change in general
     */

    virtual Result timerUpdate() /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
