
#ifndef NMM_INetClient_HPP
#define NMM_INetClient_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class INetClient : virtual public Interface { 
  public:
    INetClient() {  setTypeInfo(TypeInfo(INetClient::INetClient_type, "NMM")); };

    INetClient(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(INetClient::INetClient_type, "NMM")); setEventReceiver(parent); };

    virtual ~INetClient() {};

    static const char* INetClient_type;

    virtual  string getInterfaceType() const { return INetClient_type; }

    Interface* copy() const { return new INetClient(*this); }
    static const char* setHostname_event;
    static const char* setPort_event;
    static const char* setProtocol_event;
    static const char* getHostname_event;
    static const char* getPort_event;
    static const char* getProtocol_event;
    static const char* connectionLost_event;
    static Event* create_connectionLost();

    virtual void setHostname(const string& value)
      throw(const Exception&);

    virtual void setPort(const int& port)
      throw(const Exception&);

    virtual void setProtocol(const string& protocol)
      throw(const Exception&);

    virtual string getHostname() const
      throw(const Exception&);

    virtual int getPort() const
      throw(const Exception&);

    virtual string getProtocol() const
      throw(const Exception&);
  /* instream (protected) and non-instream (public) */    
    virtual void connectionLost() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<INetClient> INetClient_var;




}

#endif
