
#ifndef NMM_INetClientImpl_HPP
#define NMM_INetClientImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "INetClient.hpp"


namespace NMM
{

  class INetClientImpl  : public virtual NMMObject { 
  public:
    INetClientImpl() { addInterface(new INetClient(*this)); registerEvents(); };

    virtual ~INetClientImpl() {};

  protected:

    virtual void setHostname(const string& value) = 0;

    virtual void setPort(const int& port) = 0;

    virtual void setProtocol(const string& protocol) = 0;

    virtual string getHostname() const = 0;

    virtual int getPort() const = 0;

    virtual string getProtocol() const = 0;

    virtual void connectionLost() /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
