
#ifndef NMM_INetImpl_HPP
#define NMM_INetImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "INet.hpp"

#include "nmm/interfaces/base/INodeImpl.hpp"

namespace NMM
{

  class INetImpl  : public virtual NMMObject { 
  public:
    INetImpl() { addInterface(new INet(*this)); registerEvents(); };

    virtual ~INetImpl() {};

  protected:
    /**
     * Set the transport strategy to the TSAddress address.
     * Tells the NetNode which transport strategy to use.
     */

    virtual void setTransportStrategy(const TSAddress* address) 
      throw(const BindingException&) = 0;

    virtual void setRTPStrategy(const string& address, const int& rtp_port, const int& rtcp_port) /* limited(INode::CONSTRUCTED) */ = 0;

    virtual void setPayloadType(const int& type) = 0;

    virtual int getPayloadType() const = 0;


  private:
    void registerEvents();
  };

}

#endif
