
#ifndef NMM_IObjectAcceptorImpl_HPP
#define NMM_IObjectAcceptorImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IObjectAcceptor.hpp"


namespace NMM
{

  class IObjectAcceptorImpl  : public virtual NMMObject { 
  public:
    IObjectAcceptorImpl() { addInterface(new IObjectAcceptor(*this)); registerEvents(); };

    virtual ~IObjectAcceptorImpl() {};

  protected:

    virtual void connectToObject(const NMMReference& reference) 
      throw(const BindingException&) = 0;

    virtual void connectToService(const string& service) 
      throw(const BindingException&) = 0;

    virtual list<string >  getServiceList() const = 0;


  private:
    void registerEvents();
  };

}

#endif
