
#ifndef NMM_IRTPParametersImpl_HPP
#define NMM_IRTPParametersImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IRTPParameters.hpp"


namespace NMM
{

  class IRTPParametersImpl  : public virtual NMMObject { 
  public:
    IRTPParametersImpl() { addInterface(new IRTPParameters(*this)); registerEvents(); };

    virtual ~IRTPParametersImpl() {};

  protected:

    virtual string getRTPSinkMediaType() const = 0;

    virtual unsigned char getRTPSinkPayloadType() const = 0;

    virtual string getRTPSinkMapLine() const = 0;

    virtual string getRTPSinkAuxSDPLine() const = 0;

    virtual unsigned short getRTPSeqNum() const = 0;

    virtual unsigned int getRTPTimestamp() const = 0;

    virtual unsigned int getRTPPort() const = 0;

    virtual unsigned int getRTCPPort() const = 0;


  private:
    void registerEvents();
  };

}

#endif
