
#ifndef NMM_IURL_HPP
#define NMM_IURL_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IURL : virtual public Interface { 
  public:
    IURL() {  setTypeInfo(TypeInfo(IURL::IURL_type, "NMM")); };

    IURL(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IURL::IURL_type, "NMM")); setEventReceiver(parent); };

    virtual ~IURL() {};

    static const char* IURL_type;

    virtual  string getInterfaceType() const { return IURL_type; }

    Interface* copy() const { return new IURL(*this); }
    static const char* setURL_event;
    static const char* getURL_event;

    virtual void setURL(const string& url)
      throw(const Exception&);

    virtual string getURL() const
      throw(const Exception&);


  };

  typedef auto_ptr<IURL> IURL_var;




}

#endif
