
#ifndef NMM_IBufferCounter_HPP
#define NMM_IBufferCounter_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   * Interfae for counting the buffers processed by a node.
   */

  class IBufferCounter : virtual public Interface { 
  public:
    IBufferCounter() {  setTypeInfo(TypeInfo(IBufferCounter::IBufferCounter_type, "NMM")); };

    IBufferCounter(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IBufferCounter::IBufferCounter_type, "NMM")); setEventReceiver(parent); };

    virtual ~IBufferCounter() {};

    static const char* IBufferCounter_type;

    virtual  string getInterfaceType() const { return IBufferCounter_type; }

    Interface* copy() const { return new IBufferCounter(*this); }
    static const char* getBuffersPassed_event;
    static const char* resetBufferCounter_event;
    /**
     * Get number of buffers processed.
     * Returns the current value of the buffer counter.
     */

    virtual int getBuffersPassed() const
      throw(const Exception&);
    /**
     * Reset the buffer counter.
     * Resets the buffer counter to zero buffers processed.
     */

    virtual void resetBufferCounter()
      throw(const Exception&);


  };

  typedef auto_ptr<IBufferCounter> IBufferCounter_var;




}

#endif
