
#include "IByteCounter.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  int IByteCounter::getSendingCounter()
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IByteCounter::getSendingCounter");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int IByteCounter::getReceivingCounter()
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IByteCounter::getReceivingCounter");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IByteCounter::resetSendingCounter()
      throw(const Exception&)
  {
    Event event("IByteCounter::resetSendingCounter");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IByteCounter::resetReceivingCounter()
      throw(const Exception&)
  {
    Event event("IByteCounter::resetReceivingCounter");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IByteCounter::IByteCounter_type = "IByteCounter";
  TIFactoryObject<IByteCounter > __IByteCounter_prototype("IByteCounter");


  const char* IByteCounter::getSendingCounter_event = "IByteCounter::getSendingCounter";
  const char* IByteCounter::getReceivingCounter_event = "IByteCounter::getReceivingCounter";
  const char* IByteCounter::resetSendingCounter_event = "IByteCounter::resetSendingCounter";
  const char* IByteCounter::resetReceivingCounter_event = "IByteCounter::resetReceivingCounter";


}


