
#include "ISleep.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ISleep::setSleepTime(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ISleep::setSleepTime", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  int ISleep::getSleepTime() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ISleep::getSleepTime");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISleep::ISleep_type = "ISleep";
  TIFactoryObject<ISleep > __ISleep_prototype("ISleep");


  const char* ISleep::setSleepTime_event = "ISleep::setSleepTime";
  const char* ISleep::getSleepTime_event = "ISleep::getSleepTime";


}


