
#include "ICrop.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ICrop::setCrop(const int& xOffset, const int& yOffset, const int& xRange, const int& yRange) /* required(INode::INITIALIZED, INode::OUTPUT_INITIALIZED) */ /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<int > xOffset_value(xOffset, false);
    TInValue<int > yOffset_value(yOffset, false);
    TInValue<int > xRange_value(xRange, false);
    TInValue<int > yRange_value(yRange, false);
    Event event("ICrop::setCrop", &xOffset_value, &yOffset_value, &xRange_value, &yRange_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }

  const char* ICrop::ICrop_type = "ICrop";
  TIFactoryObject<ICrop > __ICrop_prototype("ICrop");


  const char* ICrop::setCrop_event = "ICrop::setCrop";


}


