
#ifndef NMM_ICameraImpl_HPP
#define NMM_ICameraImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ICamera.hpp"


namespace NMM
{

  class ICameraImpl  : public virtual NMMObject { 
  public:
    ICameraImpl() { addInterface(new ICamera(*this)); registerEvents(); };

    virtual ~ICameraImpl() {};

  protected:

    virtual void setBrightness(const int& value) = 0;

    virtual void setAutoExposure(const int& value) = 0;

    virtual void setSharpness(const int& value) = 0;

    virtual void setWhiteBalance(const int& value) = 0;

    virtual void setBlueBalance(const int& value) = 0;

    virtual void setRedBalance(const int& value) = 0;

    virtual void setHue(const int& value) = 0;

    virtual void setSaturation(const int& value) = 0;

    virtual void setGamma(const int& value) = 0;

    virtual void setShutter(const int& value) = 0;

    virtual void setGain(const int& value) = 0;

    virtual void setIris(const int& value) = 0;

    virtual void setFocus(const int& value) = 0;

    virtual void setZoom(const int& value) = 0;

    virtual void onePush() = 0;

    virtual int getBrightness() const = 0;

    virtual int getAutoExposure() const = 0;

    virtual int getSharpness() const = 0;

    virtual int getWhiteBalance() const = 0;

    virtual int getBlueBalance() const = 0;

    virtual int getRedBalance() const = 0;

    virtual int getHue() const = 0;

    virtual int getSaturation() const = 0;

    virtual int getGamma() const = 0;

    virtual int getShutter() const = 0;

    virtual int getGain() const = 0;

    virtual int getIris() const = 0;

    virtual int getFocus() const = 0;

    virtual int getZoom() const = 0;

    virtual pair<int, int >  getBrightnessRange() const = 0;

    virtual pair<int, int >  getAutoExposureRange() const = 0;

    virtual pair<int, int >  getSharpnessRange() const = 0;

    virtual pair<int, int >  getWhiteBalanceRange() const = 0;

    virtual pair<int, int >  getHueRange() const = 0;

    virtual pair<int, int >  getSaturationRange() const = 0;

    virtual pair<int, int >  getGammaRange() const = 0;

    virtual pair<int, int >  getShutterRange() const = 0;

    virtual pair<int, int >  getGainRange() const = 0;

    virtual pair<int, int >  getIrisRange() const = 0;

    virtual pair<int, int >  getFocusRange() const = 0;

    virtual pair<int, int >  getZoomRange() const = 0;

    virtual bool hasBrightness() const = 0;

    virtual bool hasAutoExposure() const = 0;

    virtual bool hasSharpness() const = 0;

    virtual bool hasWhiteBalance() const = 0;

    virtual bool hasHue() const = 0;

    virtual bool hasSaturation() const = 0;

    virtual bool hasGamma() const = 0;

    virtual bool hasShutter() const = 0;

    virtual bool hasGain() const = 0;

    virtual bool hasIris() const = 0;

    virtual bool hasFocus() const = 0;

    virtual bool hasZoom() const = 0;


  private:
    void registerEvents();
  };

}

#endif
