
#include "ITextDisplay.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ITextDisplay::setFontImage(const string& path)
      throw(const Exception&)
  {
    TInValue<string > path_value(path, false);
    Event event("ITextDisplay::setFontImage", &path_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ITextDisplay::ITextDisplay_type = "ITextDisplay";
  TIFactoryObject<ITextDisplay > __ITextDisplay_prototype("ITextDisplay");


  const char* ITextDisplay::setFontImage_event = "ITextDisplay::setFontImage";


}


