
#include "IMPEGVideoDecoder.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IMPEGVideoDecoder::resyncMPEG() /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IMPEGVideoDecoder::resyncMPEG");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IMPEGVideoDecoder::IMPEGVideoDecoder_type = "IMPEGVideoDecoder";
  TIFactoryObject<IMPEGVideoDecoder > __IMPEGVideoDecoder_prototype("IMPEGVideoDecoder");


  const char* IMPEGVideoDecoder::resyncMPEG_event = "IMPEGVideoDecoder::resyncMPEG";
  Event* IMPEGVideoDecoder::create_resyncMPEG()
  {

    return new Event("IMPEGVideoDecoder::resyncMPEG");
  }



}


