
#ifndef NMM_IMPEGVideoDecoder_HPP
#define NMM_IMPEGVideoDecoder_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IMPEGVideoDecoder : virtual public Interface { 
  public:
    IMPEGVideoDecoder() {  setTypeInfo(TypeInfo(IMPEGVideoDecoder::IMPEGVideoDecoder_type, "NMM")); };

    IMPEGVideoDecoder(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IMPEGVideoDecoder::IMPEGVideoDecoder_type, "NMM")); setEventReceiver(parent); };

    virtual ~IMPEGVideoDecoder() {};

    static const char* IMPEGVideoDecoder_type;

    virtual  string getInterfaceType() const { return IMPEGVideoDecoder_type; }

    Interface* copy() const { return new IMPEGVideoDecoder(*this); }
    static const char* resyncMPEG_event;
    static Event* create_resyncMPEG();
  /* instream (protected) and non-instream (public) */    
    virtual Result resyncMPEG() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<IMPEGVideoDecoder> IMPEGVideoDecoder_var;




}

#endif
