
#include "IMPEGVideoEncoder.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IMPEGVideoEncoder::setMPEGVersion(const unsigned int& version)
      throw(const Exception&)
  {
    TInValue<unsigned int > version_value(version, false);
    Event event("IMPEGVideoEncoder::setMPEGVersion", &version_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IMPEGVideoEncoder::setEncodingThreadCount(const unsigned int& number)
      throw(const Exception&)
  {
    TInValue<unsigned int > number_value(number, false);
    Event event("IMPEGVideoEncoder::setEncodingThreadCount", &number_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IMPEGVideoEncoder::IMPEGVideoEncoder_type = "IMPEGVideoEncoder";
  TIFactoryObject<IMPEGVideoEncoder > __IMPEGVideoEncoder_prototype("IMPEGVideoEncoder");


  const char* IMPEGVideoEncoder::setMPEGVersion_event = "IMPEGVideoEncoder::setMPEGVersion";
  const char* IMPEGVideoEncoder::setEncodingThreadCount_event = "IMPEGVideoEncoder::setEncodingThreadCount";


}


