
#include "IOSDSetFont.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IOSDSetFont::setFont(const string& font_name, const float& font_factor)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > font_name_value(font_name, false);
    TInValue<float > font_factor_value(font_factor, false);
    Event event("IOSDSetFont::setFont", &font_name_value, &font_factor_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IOSDSetFont::IOSDSetFont_type = "IOSDSetFont";
  TIFactoryObject<IOSDSetFont > __IOSDSetFont_prototype("IOSDSetFont");


  const char* IOSDSetFont::setFont_event = "IOSDSetFont::setFont";


}


