
#include "IBorderDecorator.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IBorderDecorator::setBorderWidth(const unsigned int& bw)
      throw(const Exception&)
  {
    TInValue<unsigned int > bw_value(bw, false);
    Event event("IBorderDecorator::setBorderWidth", &bw_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IBorderDecorator::setBorderColor(const u_int32_t& color)
      throw(const Exception&)
  {
    TInValue<u_int32_t > color_value(color, false);
    Event event("IBorderDecorator::setBorderColor", &color_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IBorderDecorator::IBorderDecorator_type = "IBorderDecorator";
  TIFactoryObject<IBorderDecorator > __IBorderDecorator_prototype("IBorderDecorator");


  const char* IBorderDecorator::setBorderWidth_event = "IBorderDecorator::setBorderWidth";
  const char* IBorderDecorator::setBorderColor_event = "IBorderDecorator::setBorderColor";


}


