
#ifndef NMM_IDecoratorImpl_HPP
#define NMM_IDecoratorImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IDecorator.hpp"

#include "IWidgetImpl.hpp"

namespace NMM
{
  /**
   * Decorator interface.
   */

  class IDecoratorImpl  : virtual public IWidgetImpl { 
  public:
    IDecoratorImpl() { addInterface(new IDecorator(*this)); registerEvents(); };

    virtual ~IDecoratorImpl() {};

  protected:
    /** Get internal widget. */

    virtual IWidget* getInternalWidget() const = 0;
    /** Set internal widget. */

    virtual void setInternalWidget(const IWidget& widget) = 0;


  private:
    void registerEvents();
  };

}

#endif
