
#include "IHeaderDecorator.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IHeaderDecorator::setFont(const string& value)
      throw(const Exception&)
  {
    TInValue<string > value_value(value, false);
    Event event("IHeaderDecorator::setFont", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IHeaderDecorator::setText(const string& value)
      throw(const Exception&)
  {
    TInValue<string > value_value(value, false);
    Event event("IHeaderDecorator::setText", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IHeaderDecorator::IHeaderDecorator_type = "IHeaderDecorator";
  TIFactoryObject<IHeaderDecorator > __IHeaderDecorator_prototype("IHeaderDecorator");


  const char* IHeaderDecorator::setFont_event = "IHeaderDecorator::setFont";
  const char* IHeaderDecorator::setText_event = "IHeaderDecorator::setText";


}


