
#ifndef NMM_IHeaderDecoratorImpl_HPP
#define NMM_IHeaderDecoratorImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IHeaderDecorator.hpp"

#include "IDecoratorImpl.hpp"

namespace NMM
{
  /**
   * Header decorator interface.
   */

  class IHeaderDecoratorImpl  : virtual public IDecoratorImpl { 
  public:
    IHeaderDecoratorImpl() { addInterface(new IHeaderDecorator(*this)); registerEvents(); };

    virtual ~IHeaderDecoratorImpl() {};

  protected:
    /**
     * Set header font.
     * Set the font that is used to draw the text.
     * @param value font name
     */

    virtual void setFont(const string& value) = 0;
    /**
     * Set header text.
     * Set the text that should be displayed in the header.
     * @param value header text
     */

    virtual void setText(const string& value) = 0;


  private:
    void registerEvents();
  };

}

#endif
