
#ifndef NMM_IPlaneDecorator_HPP
#define NMM_IPlaneDecorator_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IDecorator.hpp"

namespace NMM
{
  /**
   * Plane decorator interface.
   */

  class IPlaneDecorator : virtual public IDecorator { 
  public:
    IPlaneDecorator() {  setTypeInfo(TypeInfo(IPlaneDecorator::IPlaneDecorator_type, "NMM")); };

    IPlaneDecorator(NMMObject& parent) : IDecorator(parent) {  setTypeInfo(TypeInfo(IPlaneDecorator::IPlaneDecorator_type, "NMM")); setEventReceiver(parent); };

    virtual ~IPlaneDecorator() {};

    static const char* IPlaneDecorator_type;

    virtual  string getInterfaceType() const { return IPlaneDecorator_type; }

    Interface* copy() const { return new IPlaneDecorator(*this); }
    static const char* setPlaneColor_event;
    /**
     * Set plane color.
     * @param color 32 bit border color (rgba format)
     */

    virtual void setPlaneColor(const u_int32_t& color)
      throw(const Exception&);


  };

  typedef auto_ptr<IPlaneDecorator> IPlaneDecorator_var;




}

#endif
