
#ifndef NMM_ISymbolChange_HPP
#define NMM_ISymbolChange_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   * Symbol has changed.
   * Instream event, sent by the OSDManager when the symbol has been changed.
   * The event is sent after the first video frame that contains the new symbol.
   */

  class ISymbolChange : virtual public Interface { 
  public:
    ISymbolChange() {  setTypeInfo(TypeInfo(ISymbolChange::ISymbolChange_type, "NMM")); };

    ISymbolChange(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ISymbolChange::ISymbolChange_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISymbolChange() {};

    static const char* ISymbolChange_type;

    virtual  string getInterfaceType() const { return ISymbolChange_type; }

    Interface* copy() const { return new ISymbolChange(*this); }
    static const char* symbolChanged_event;
    static Event* create_symbolChanged(const string& symbol);
  /* instream (protected) and non-instream (public) */    
    virtual Result symbolChanged(const string& symbol) /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ISymbolChange> ISymbolChange_var;




}

#endif
