
#include "ITimeView.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ITimeView::setFont(const string& value)
      throw(const Exception&)
  {
    TInValue<string > value_value(value, false);
    Event event("ITimeView::setFont", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITimeView::setPrefix(const string& value)
      throw(const Exception&)
  {
    TInValue<string > value_value(value, false);
    Event event("ITimeView::setPrefix", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITimeView::setTimeOffset(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ITimeView::setTimeOffset", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITimeView::setCurrentTime(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ITimeView::setCurrentTime", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  int ITimeView::getCurrentTime()
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ITimeView::getCurrentTime");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ITimeView::reset()
      throw(const Exception&)
  {
    Event event("ITimeView::reset");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ITimeView::ITimeView_type = "ITimeView";
  TIFactoryObject<ITimeView > __ITimeView_prototype("ITimeView");


  const char* ITimeView::setFont_event = "ITimeView::setFont";
  const char* ITimeView::setPrefix_event = "ITimeView::setPrefix";
  const char* ITimeView::setTimeOffset_event = "ITimeView::setTimeOffset";
  const char* ITimeView::setCurrentTime_event = "ITimeView::setCurrentTime";
  const char* ITimeView::getCurrentTime_event = "ITimeView::getCurrentTime";
  const char* ITimeView::reset_event = "ITimeView::reset";


}


