
#ifndef NMM_IWidgetComposite_HPP
#define NMM_IWidgetComposite_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IWidget.hpp"

namespace NMM
{
  /**
   * Widget composite interfaced.
   */

  class IWidgetComposite : virtual public IWidget { 
  public:
    IWidgetComposite() {  setTypeInfo(TypeInfo(IWidgetComposite::IWidgetComposite_type, "NMM")); };

    IWidgetComposite(NMMObject& parent) : IWidget(parent) {  setTypeInfo(TypeInfo(IWidgetComposite::IWidgetComposite_type, "NMM")); setEventReceiver(parent); };

    virtual ~IWidgetComposite() {};

    static const char* IWidgetComposite_type;

    virtual  string getInterfaceType() const { return IWidgetComposite_type; }

    Interface* copy() const { return new IWidgetComposite(*this); }
    static const char* add_event;
    static const char* remove_event;
    static const char* removeAll_event;
    /** Add widget to composite object. */

    virtual void add(const IWidget& wg)
      throw(const Exception&);
    /** Remove widget from composite object. */

    virtual void remove(const IWidget& wg)
      throw(const Exception&);
    /** Remove all widgets from composite object. */

    virtual void removeAll()
      throw(const Exception&);


  };

  typedef auto_ptr<IWidgetComposite> IWidgetComposite_var;




}

#endif
