
#ifndef NMM_IChannelInfoImpl_HPP
#define NMM_IChannelInfoImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IChannelInfo.hpp"

#include "nmm/interfaces/base/INodeImpl.hpp"

namespace NMM
{
  /**
   *Interface for requesting channel-information from the Node. It is used to build the global channel-list.
   */

  class IChannelInfoImpl  : public virtual NMMObject { 
  public:
    IChannelInfoImpl() { addInterface(new IChannelInfo(*this)); registerEvents(); };

    virtual ~IChannelInfoImpl() {};

  protected:
    /**
     *Tests, if the TVCard has the channel with the given name. It writes the corrensponding channel-number to c1
     */

    virtual Result hasChannel(int& c1, const string& c2) = 0;
    /**
     *Returns a complete List of all available channels
     *@return TVCannelList the channel-list
     */

    virtual TVChannelList getChannelList() = 0;
    /**
     *Tell the node to read the channel-configuration from the given file. 
     *@param filename complete path to the channel-configuration-file
     */

    virtual void setChannelConfigFile(const string& filename) /* limited(INode::CONSTRUCTED) */ = 0;


  private:
    void registerEvents();
  };

}

#endif
