/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */



#ifndef _NMM_LCDWRITER_HPP_
#define _NMM_LCDWRITER_HPP_ _NMM_LCDWRITER_HPP_

#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <time.h>

#include "nmm/utils/thread/Thread.hpp"
#include "nmm/NMMTypes.hpp"

extern "C" {
#include "lcd_2x20.h"
};

#define LINE_LENGTH 20

namespace NMM {

  class LCDWriter
  {
  private:
    bool               isScrollingLine0;
    bool               isScrollingLine1;
    struct LCDctrl     l;
    int                fd;
    static const unsigned char  bars[];
    static const char* emptyLine;
    ThreadMutex        event_mutex;
    
  public:
    LCDWriter ();
    ~LCDWriter ();
    
    Result init();
    int clear();
    int setText (int line, const char* text);
    int setDateTime (int line);
    int setChar(int x, int y, char c);
    int clearLine(int line);
    void setProgressBar(int line, int percent_);
    
    Result receiveStartTrack(string&);
  };
}
#endif //_NMM_LCDWRITER_HPP_
