/* NMM - Network-Integrated Multimedia Environment
 *
 * Copyright (C) 2002 Network-Multimedia Workgroup, 
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Network-Multimedia Workgroup,
 *                    http://www.networkmultimedia.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

//void scaleImagePlane(char* out_data, int out_width, int out_height, int out_pitch,
//		     const char* in_data, int in_pitch,
//		     int in_delta_x, int in_delta_y) {
//  int y, iny = 0;
//  
//  for (y=0; y<out_height; ++y) {
//    processLine(out_data, out_width, in_data + (iny >> 16) * in_pitch, in_delta_x);
//    out_data += out_pitch;
//    iny += in_delta_y;
//  }
//}

void scaleImageRowFiltering(char* out_data, int out_width, const char* in_data, int in_pitch, int in_delta_x, int iny_frac) {
  int x, inx = 0;
  
  int vf = iny_frac >> 8;
  int ivf = 0xFF - vf;
  
  for (x=0; x<out_width; ++x) {
    int inx_int = (inx >> 16);
    int uf = (inx & 0xFFFF) >> 8;
    int iuf = 0xFF - uf;
    int c00 = (unsigned char) in_data[inx_int];
    int c01 = (unsigned char) in_data[inx_int + 1];
    int c10 = (unsigned char) in_data[in_pitch + inx_int];
    int c11 = (unsigned char) in_data[in_pitch + inx_int + 1];
    //    int c0 = (c00 * iuf + c01 * uf) >> 16;
    //    int c1 = (c10 * iuf + c10 * uf) >> 16;
    //    out_data[x] = (c0 * ivf + c1 * vf) >> 16;
    out_data[x] = ((c00 * iuf + c01 * uf) * ivf + (c10 * iuf + c11 * uf) * vf) >> 16;
    inx += in_delta_x;
  }
}

void scaleImageRow(char* out_data, int out_width, const char* in_data, int in_pitch, int in_delta_x, int iny_frac) {
  int x, inx = 0;
  
  for (x=0; x<out_width; ++x) {
    out_data[x] = in_data[inx >> 16];
    inx += in_delta_x;
  }
}

