/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */



#ifndef NMM_SINKMULTICLIENTNETNODE_HPP
#define NMM_SINKMULTICLIENTNETNODE_HPP NMM_SINKMULTICLIENTNETNODE_HPP

#include "nmm/base/GenericSinkNode.hpp"
#include "nmm/base/EventDispatcher.hpp"
#include "NetUtils.hpp"

namespace NMM {
/**
   
  */

class SinkMultiClientNetNode : public GenericSinkNode {
public: 
  //  SinkMultiClientNetNode(const char* name);
  SinkMultiClientNetNode(const char* name,
			 const StreamQueue::Mode queue_mode = StreamQueue::DEFAULT_MODE,
			 const int size = StreamQueue::DEFAULT_SIZE);

  virtual ~SinkMultiClientNetNode();

  Result setNonBlocking(bool& );
  Result setPort(int& );
  Result getPort(int& );
  Result setMaxClients(unsigned int& );
  Result getMaxClients(unsigned int& );
  Result getConnections(unsigned int& );
  Result getHostName(string& );
protected:
  virtual Buffer* processBuffer(Buffer* buffer);

  virtual Result doDeactivate();
  virtual Result doInit();
  virtual Result doActivate();

private:
  SockStream*   streams;
  SockAcceptor  s_accept;
  INetAddr      addr;
  bool* is_connected;
  bool non_blocking;
  string local_host;
  unsigned int connections;
  unsigned int max_clients;
};

} //end namepsace
#endif
