/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        NMM work group,
 *                    http://www.networkmultimedia.org
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_RGBtoYV12CONVERTERNODE_HPP_
#define _NMM_RGBtoYV12CONVERTERNODE_HPP_

#include "nmm/base/GenericConverterNode.hpp"

namespace NMM {
class RGBtoYV12ConverterNode :  public GenericProcessorNode
{

private:
    int width;
    int height;
    bool hasmmx;

    void rgb2yuv( unsigned char R, unsigned char G, unsigned char B, double *Y, double *U, double *V );
    void rgb32_to_YV12( unsigned char *rgb_image, unsigned char *yuv_image );
    void rgb24_to_YV12( unsigned char *rgb_image, unsigned char *yuv_image );
    void rgb565_to_YV12( unsigned char *rgb_image, unsigned char *yuv_image );

protected:
   virtual Message* processBuffer(Buffer* in_buffer);
    
  virtual Result doInit();
  virtual Result doInitOutput();
  virtual Result doActivate();

  virtual Result doSetFormat(const Format& format);

public:
  enum { RGB32, RGB24, RGB565 } __format;
  RGBtoYV12ConverterNode( const char * = "RGBtoYV12ConverterNode", StreamQueue::Mode = StreamQueue::MODE_SUSPEND, int = 20);
  ~RGBtoYV12ConverterNode() {};

};

}

#endif //_NMM_RGBtoYV12CONVERTERNODE_HPP_
