/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_VIDEOCROPNODE_HPP_
#define _NMM_VIDEOCROPNODE_HPP_ _NMM_VIDEOCROPNODE_HPP_

#include "nmm/base/GenericProcessorNode.hpp"
#include "nmm/interfaces/video/ICropImpl.hpp"

namespace NMM {
  class VideoCropNode :
    public GenericProcessorNode,
    public ICropImpl
  {  
  protected:
    virtual Message* processBuffer(Buffer* in_buffer);
    
    virtual Result doInit();
    virtual Result doInitOutput();

    virtual void setCrop(const int& xOffset, const int& yOffset, const int& xRange, const int& yRange);
    
  public:
    VideoCropNode(const char *name = "VideoCropNode",
		  const StreamQueue::Mode queue_mode = StreamQueue::DEFAULT_MODE, 
		  const int queue_size = StreamQueue::DEFAULT_SIZE );
    ~VideoCropNode();
  private:
    int x_offset;
    int y_offset;
    int x_range;
    int y_range;
    int x_resolution;
    int y_resolution;

    bool send_format;
    int ratio_x;
    int ratio_y;
    string channelorder;
    string colorspace;
    string endian;
    string format;
    int bitperpixel;
    float framerate;

    Buffer* saved_buffer;
  }; 
}

#endif // _NMM_VIDEOCROPNODE_HPP_
