/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_YUVDEINTERLACENODE_HPP_
#define _NMM_YUVDEINTERLACENODE_HPP_ _NMM_YUVDEINTERLACENODE_HPP_

#include "nmm/base/GenericFilterNode.hpp"

namespace NMM {
  
  class YUVDeInterlaceNode
    : public GenericFilterNode
  {
  private:
    int width;
    int height;
    Result resize(int&, int&);
    
    Result doInit();
    Result doDeinit();
    Result doInitOutput();
    
    static void yuv_deinterlace(char *, int, int);
    static inline void rgb_average(char*, char*, char*, int);
    
    Result setupOutputFormat(const Format* in_f);
    
  protected:
    Message* processBuffer(Buffer*);
    
    Result setFormat(const Format& format);
    
  public:
    YUVDeInterlaceNode(const char *name = "YUVDeInterlaceNode",
		       const StreamQueue::Mode queue_mode = StreamQueue::MODE_SUSPEND, 
		       const int queue_size = 1 );
    ~YUVDeInterlaceNode();
  };

}

#endif // _NMM_YUVDEINTERLACENODE_HPP_
