/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_PROGRESSBARUNIT_HPP_
#define _NMM_PROGRESSBARUNIT_HPP_ _NMM_PROGRESSBARUNIT_HPP_

#include "OSDElement.hpp"

#include "nmm/interfaces/video/osd/manager/IProgressBar.hpp"
#include "nmm/interfaces/video/osd/manager/IBorderDecorator.hpp"
#include "nmm/interfaces/video/osd/manager/IPlaneDecorator.hpp"
#include "nmm/interfaces/video/osd/manager/IHeaderDecorator.hpp"

namespace NMM {
  class ProgressbarUnit : public OSDElement {
  public:
    
    ProgressbarUnit( IOSDManager* manager, IWidgetFactory* factory, string font );
    ~ProgressbarUnit();
    
    /**
     * \param color1 color of plane
     * \param color2 color of bar
     */
    void setColors( unsigned int color1, unsigned int color2 );

    /**
     * \param width the width (in pixels) of the progress bar
     */
    void setWidth(unsigned int width);

    /* methods that are passed through ProgrssBar class */
    void setMaxProgress( u_int64_t max );
    void setProgress( u_int64_t progress );
    void setBarSpaces( unsigned int space, unsigned int space_step );

    /* methods that are passed through HeaderDecorator class */
    void setHeader( string h );
    
  protected:
    string   font;
    
    void deleteWidgets();
    
    IProgressBar_var      bar;
    IPlaneDecorator_var   plane;
    IBorderDecorator_var  border;
    IHeaderDecorator_var  header;
  };
  
}

#endif //_NMM_PROGRESSBARUNIT_HPP_
