/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        NMM work group,
 *                    http://www.networkmultimedia.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include "GDParse.hpp"
#include <iostream>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

 extern unsigned int lineno;
 extern char *yytext;
 extern NMM::GraphDescription* g;
 extern list<string> plugin_list;
 extern list<string> plugin_path;
 extern set< pair<string, int> > host_list;
 extern list<NodeConfiguration> node_configuration;


extern "C"
{
  int yyparse(void);
  int yylex(void);
  int yywrap();

  void yyerror(const char *str);

}

extern int yydebug;


void select_input (FILE *fin)
{
  extern FILE *yyin;
  yyin = fin;
}

namespace NMM{
  void getGraphfromGD(string filename,GraphDescription& g2) {
//      yydebug = true;

    FILE *fin;
    g = &g2;
    fin = fopen (filename.c_str(), "r");
    if (!fin) {
      throw Exception("Graph description file not found");
    }
    select_input (fin);

    /* parse the graph description */
    yyparse ();
    cerr << endl;
  }
}
  
